<!DOCTYPE html>
<!--
-- Copyright (c) 2023 Alexander Exner.
--
-- This file is part of strom
-- (see https://gitlab.com/exner.occupational/strom).
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program. If not, see <http://www.gnu.org/licenses/>.
-->

{% extends "layout.html" %}
{% block content %}

<div class="schedules">
<h3>Zustand</h3>
<div id="state_html">loading...</object></div>
<div class="arrange-horizontally">

  {% for power_schedule in power_schedules -%}
  <div class="arrange-vertically">
    <h3>Zeitplan {{ power_schedule.get_schedule_name() }}</h3>
    <div id="{{ power_schedule.get_schedule_name() }}_schedule_html">
      loading...</object>
    </div>
    <h3>Aktionen</h3>
    <input type="datetime-local" name="" id="{{ power_schedule.get_schedule_name() }}_start">
    <input type="datetime-local" name="" id="{{ power_schedule.get_schedule_name() }}_end">
    <div class="arrange-horizontally">
      <button type="button" id="{{ power_schedule.get_schedule_name() }}_reset">Reset</button>
      {% for action_name in power_schedule.get_action_names() -%}
      <button type="button" id="{{ power_schedule.get_schedule_name() }}_action_{{ action_name }}">{{ action_name }}</button>
      {% endfor %}
    </div>
  </div>
  {% endfor %}
  <div class="arrange-vertically">
    <h3>Zeitplan {{ cover_schedule.get_schedule_name() }}</h3>
    <div id="{{ cover_schedule.get_schedule_name() }}_schedule_html">
      loading...</object>
    </div>
    <h3>Aktionen</h3>
    <input type="datetime-local" name="" id="{{ cover_schedule.get_schedule_name() }}_start">
    <div class="arrange-horizontally">
      {% for action in cover_schedule.get_schedule_enum() -%}
      <input type="checkbox" id="{{ cover_schedule.get_schedule_name() }}_action_{{ action.name }}" name="{{ cover_schedule.get_schedule_name() }}_action_{{ action.name }}" value="{{ action.name }}">
      <label for="{{ cover_schedule.get_schedule_name() }}_action_{{ action.name }}">{{ action.name }}</label><br>
      {% endfor %}
    </div>
    <div class="arrange-horizontally">
      {% for action_name in cover_schedule.get_action_names() -%}
      <button type="button" id="{{ cover_schedule.get_schedule_name() }}_action_{{ action_name }}">{{ action_name }}</button>
      {% endfor %}
    <button type="button" id="{{ cover_schedule.get_schedule_name() }}_reset">Reset</button>
    </div>
  </div>
</div>

<h3>Preisübersicht</h3>
<img id="prices_png" src="{{url_for('prices_png')}}" >
<h3>Wetter</h3>
<img id="weather_png" src="{{url_for('weather_png')}}" >
</div>



<script defer>
  Date.prototype.addHours = function(h) {
    this.setTime(this.getTime() + (h*60*60*1000));
    return this;
  }

  function prefillDates(schedule_type) {
    var now = new Date();

    now.setMinutes(now.getMinutes() - now.getTimezoneOffset());
    /* remove second/millisecond */
    now.setMilliseconds(null);
    now.setSeconds(null);
    //console.log(`${schedule_type}_start`);

    var element = document.getElementById(`${schedule_type}_start`)
    if (element) {
      element.value = now.toISOString().slice(0, -1);
    }
    var element = document.getElementById(`${schedule_type}_end`)
    if (element) {
      now.setMinutes(null);
      now.addHours(1);
      element.value = now.toISOString().slice(0, -1);
    }
  }

  var interval1 = 2000; // 2000 milis = 2 seconds
  var interval2 = 60000; // 60000 milis = 1 minute
  var interval3 = 600000; // 600000 milis = 10 minutes
  var prices = document.getElementById("prices_png");
  var weather = document.getElementById("weather_png");
  var state = document.getElementById("state_html");
  //var schedule = document.getElementById("schedule_html");

  function updatePrices() {
    prices.src = prices.src.split("?")[0] + "?" + new Date().getTime();
  }

  function updateWeather() {
    weather.src = weather.src.split("?")[0] + "?" + new Date().getTime();
  }

  function updateState() {
    //text.innerHTML='<object type="text/html" data="state.html" ></object>';
    //state.data = state.data.split("?")[0] + "?" + new Date().getTime();
    fetch("{{url_for('state_html')}}" /*, options */)
    .then((response) => response.text())
    .then((html) => {
      state.innerHTML = html;
    })
    .catch((error) => {
      console.warn(error);
    });
  }

  function deleteAction(schedule_type, start_iso, cover) {
    //console.log(schedule_type)
    //console.log(start_iso)
    json = {schedule_type: schedule_type, start_iso: start_iso}
    if (cover !== undefined) {
      json["cover"] = cover
    }
    fetch("{{url_for('delete_action')}}?" + new URLSearchParams(json),
    {
      method: "DELETE",
    })
      .then((response) => response.text())
      .then((text) => {
         console.warn(text);
      });
    updateSchedule(schedule_type);
    clearInterval(int2); /* Prices Chart */
    updatePrices();
    int2 = setInterval(updatePrices, interval2);
  }

  function updateSchedule(schedule_type) {
    var schedule = document.getElementById(`${schedule_type}_schedule_html`);
    fetch("{{url_for('schedule_html')}}?" + new URLSearchParams({schedule_type: schedule_type}))
    .then((response) => response.text())
    .then((html) => {
      schedule.innerHTML = html;
    })
    .catch((error) => {
      console.warn(error);
    });
  }

  var int1 = setInterval(updateState, interval1);
  var int2 = setInterval(updatePrices, interval2);
  var int3 = setInterval(updateWeather, interval3);

  function scheduleAdd(schedule_type, state) {
    var start = document.getElementById(`${schedule_type}_start`);
    var end = document.getElementById(`${schedule_type}_end`);
    if (end) {
      // some power action
      json = {schedule_type: schedule_type, state: state, start: start.value, end: end.value}
    } else {
      // cover action
      var covers =[];
      {% for action in cover_schedule.get_schedule_enum() -%}
      var cover_checkbox_element = "{{ cover_schedule.get_schedule_name() }}_action_{{ action.name }}"
      if (document.getElementById(cover_checkbox_element).checked) {
          covers.push("{{ action.name }}")
      }
      {% endfor %}
      json = {schedule_type: schedule_type, state: state, start: start.value, covers: covers}
    }
    fetch("{{url_for('schedule_add')}}",
    {
      method: "POST",
      headers: { "Content-Type": "application/json" },
      body: JSON.stringify(json)
    })
      .then((response) => response.text())
      .then((text) => {
         console.warn(text);
      });
    updateSchedule(schedule_type);
    clearInterval(int2); /* Prices Chart */
    updatePrices();
    int2 = setInterval(updatePrices, interval2);
  }

  {% for schedule in power_schedules + [cover_schedule] -%}
  updateSchedule('{{ schedule.get_schedule_name() }}');
  prefillDates('{{ schedule.get_schedule_name() }}');
  document.getElementById("{{ schedule.get_schedule_name() }}_reset").onclick = prefillDates('{{ schedule.get_schedule_name() }}');
  {% for action_name in schedule.get_action_names() -%}
  document.getElementById("{{ schedule.get_schedule_name() }}_action_{{ action_name }}").onclick = function() { scheduleAdd('{{ schedule.get_schedule_name() }}', '{{ action_name }}'); };
  {% endfor %}
  {% endfor %}

</script>

{% endblock %}
